function [ sigma_dot ] = find_sigma_dot(x,y,nu,x_obs,y_obs,v_obs, psi_obs,sigma)

global k wp

RotMat = @(theta) [cos(theta) -sin(theta); sin(theta) cos(theta)];

u = nu(1); v = nu(2);

x_last = wp(k,1);
y_last = wp(k,2);
x_next = wp(k+1,1);
y_next = wp(k+1,2);

alpha = atan2(y_next-y_last,x_next-x_last);
e = -(x-x_last)*sin(alpha) + (y-y_last)*cos(alpha);
delta = 40; 

chi_p = alpha;
chi_r = atan2(-e,delta);
psi_d = chi_p + chi_r;

p = RotMat(psi_d)*[u; v];
x_dot = p(1); y_dot = p(2);

p_obs = RotMat(psi_obs)*v_obs;
x_obs_dot = p_obs(1); y_obs_dot = p_obs(2);


sigma_dot = ((x-x_obs)*(x_dot-x_obs_dot)+(y-y_obs)*(y_dot-y_obs_dot))/sigma;

    %{
    p_A = [x; y];
    p_B = [x_obs; y_obs];
    %v_A = [nu(1);nu(2)];
    u_d = 10;
    v_A = [u_d*cos(psi_d); u_d*sin(psi_d)];
    v_B =  v_obs;
    v_AB = v_A - v_B;
    v_AB_norm = norm(v_AB);
    t_CAP = 0;
    epsilon = 0.0001;
    if v_AB_norm > epsilon
        t_CAP = dot(p_A-p_B,v_A-v_B)/(v_AB_norm^2)
    end
    d_CAP = norm((p_A+v_A*t_CAP)-(p_B+v_B*t_CAP));
    if t_CAP < 0 && sigma >= 60
       sigma_dot = 1000
    end
%}
end

