function [ tau ] = low_level_controller( nu, eta, u_d, psi_d, r_d )

global X_u X_uu X_uuu m I_z l_r Kp_u Kp_psi Td_psi

%{
Fx_min = -6550.0;
Fx_max = 13100.0;
Fy_min =  -645.0;
Fy_max =   645.0;
%}
u = nu(1); v = nu(2); r = nu(3);
psi = eta(3);

gamma = (psi_d-psi);

F_x = -X_u*u-X_uu*abs(u)*u-X_uuu*u^3-m*r*v+Kp_u*m*(u_d-u);
F_y = (Kp_psi*I_z*(gamma+Td_psi*(r_d-r)))/l_r;
%{
if isinf(F_x)
    disp('inf Fx');
    if F_x < Fx_min
        F_x = Fx_min;
    elseif F_x > Fx_max
        F_x = Fx_max;
    end
end
if isinf(F_y)
    disp('inf Fy');
    if F_y < Fy_min
        F_y = Fy_min;
    elseif F_y > Fy_max
        F_y = Fy_max;
    end
end
%}
tau = [F_x F_y l_r*F_y]';

end

