function [ ] = new_wp( p_ASV,v_ASV, p_obs, v_obs, psi_obs, R_s, R_ss )

global wp wp_oa k
RotMat = @(theta) [cos(theta) -sin(theta); sin(theta) cos(theta)];


bearing = atan2(p_ASV(2)-p_obs(2),p_ASV(1)-p_obs(1))-psi_obs; % Relative bearing (Loe,2008)
%Normalize bearing to [0,2pi):
while bearing < 0
    bearing = bearing + 2*pi;
end
while bearing >= 2*pi
    bearing = bearing - 2*pi;
end

colregs_situation = inColregsSituation_sbg( bearing );

if colregs_situation == 1% HEAD_ON

    v_dist = v_ASV - v_obs;
    v_dist_norm = norm(v_dist);

    t_CAP = 0;
    if v_dist_norm > 0.0001
        t_CAP =-dot(p_ASV-p_obs,v_ASV-v_obs)/(v_dist_norm^2);
    end
    p_obs = p_obs + v_obs*(t_CAP+1); 
    if colregs_situation == 4
        p_obs = p_obs + v_obs*(t_CAP+3);
    end
end

next_wp = [wp(k+1,1); wp(k+1,2)];

A = p_ASV;
C = p_obs;
W = next_wp;

CA = A-C;
CW = W-C;
CB = CW/norm(CW)*R_s;

%B = C + CB;

%theta = acos(dot(CA,CB)/(norm(CA)*norm(CB)));
angle = atan2(CB(2),CB(1))-atan2(CA(2),CA(1));
if (angle < 0) 
    angle = angle + 2*pi;
end

side = 1; % pass on right side of ostacle
num_wp_oa = 1; % use one extra wp to pass obstacle 

% 'HEAD_ON' = 1 'CROSSING_RIGHT' = 2 CROSSING_LEFT' = 3 'OVERTAKING' = 4
% right = 1, left = 2

if colregs_situation == 1 ||  colregs_situation == 2 
    %HEAD ON or CROSSING RIGHT
    side = 1;
elseif colregs_situation == 3 % CROSSING LEFT
    num_wp_oa = 0;
else % OVERTAKING
    if angle == pi*5/4
        side = 1;
    elseif angle > pi*5/4
        side = 2; %left
    end
end

d2 = dot(CW,CW); %(length of CW)^2
Q0 = C+R_ss^2/d2*CW;
T = (R_ss/d2*sqrt(d2-R_ss^2)*CW'*[0 1;-1 0])';
Q1 = Q0+T;
Q2 = Q0-T;

CQ1 = Q1-C;
CQ2 = Q2-C;

d2_a = dot(CA,CA);
Q0_a = C+R_ss^2/d2_a*CA;
T_a = (R_ss/d2_a*sqrt(d2_a-R_ss^2)*CA'*[0 1;-1 0])';
Q1_a = Q0_a+T_a;
Q2_a = Q0_a-T_a;

CQ1_a = Q1_a-C;
CQ2_a = Q2_a-C;

theta_r = acos(dot(CQ1_a,CQ2)/(norm(CQ1_a)*norm(CQ2)));
theta_l = acos(dot(CQ2_a,CQ1)/(norm(CQ2_a)*norm(CQ1)));

if side == 1 && theta_r >pi*3/4
    num_wp_oa = 2;
end

if side == 2 && theta_l >pi*3/4
    num_wp_oa = 2;
end

if side == 1    
    %if num_wp_oa == 1
        p_a1 = A; 
        p_a2 = Q1_a;
        p_b1 = W;
        p_b2 = Q2;
        
        if ~isreal(p_a2) || ~isreal(p_b2)
            disp('not real')
        else
        
            % exted the line segment checked for intersection
            p_a1(1) = p_a1(1)+(p_a1(1)-p_a2(1))*10;
            p_a1(2) = p_a1(2)+(p_a1(2)-p_a2(2))*10;
            p_a2(1) = p_a2(1)+(p_a2(1)-p_a1(1))*10;
            p_a2(2) = p_a2(2)+(p_a2(2)-p_a1(2))*10;
            p_b1(1) = p_b1(1)+(p_b1(1)-p_b2(1))*10;
            p_b1(2) = p_b1(2)+(p_b1(2)-p_b2(2))*10;
            p_b2(1) = p_b2(1)+(p_b2(1)-p_b1(1))*10;
            p_b2(2) = p_b2(2)+(p_b2(2)-p_b1(2))*10;

            x1 = [p_a1(1) p_a2(1)]'; y1 = [p_a1(2) p_a2(2)]';
            x2 = [p_b1(1) p_b2(1)]'; y2 = [p_b1(2) p_b2(2)]';
            [xi,yi] = polyxpoly(x1,y1,x2,y2);
            intersection_point = [xi;yi];
            wp_oa = [wp_oa; intersection_point'];
        end
    %{
    elseif num_wp_oa == 2
        CD = RotMat(theta_r/2)*CQ1_a;
        D = C + CD;
        
        p_a1 = A; p_a2 = Q1_a;
        p_b1 = W; p_b2 = Q2;
        intersection_point1 = find_intersection(Q_a,D,CQ_a,CD);
        intersection_point2 = find_intersection(D,Q,CD,CQ);

        wp_oa = [wp_oa; intersection_point1'; intersection_point2'];
%}
   % end
elseif side == 2
    p_a1 = A; p_a2 = Q2_a;
    p_b1 = W; p_b2 = Q1;
    x1 = [p_a1(1) p_a2(1)]'; y1 = [p_a1(2) p_a2(2)]';
    x2 = [p_b1(1) p_b2(1)]'; y2 = [p_b1(2) p_b2(2)]';
    [xi,yi] = polyxpoly(x1,y1,x2,y2);
    intersection_point = [xi;yi];
    wp_oa = [wp_oa; intersection_point'];
end
    
%{
if colregs_situation == 4 % || colregs_situation == 1%OVERTAKING
   % if colregs_situation == 4
    v_dist = v_ASV - v_obs;
    v_dist_norm = norm(v_dist);
    t_CAP = 0;
    if v_dist_norm > 0.0001
        t_CAP =-dot(p_ASV-p_obs,v_ASV-v_obs)/(v_dist_norm^2);
    end
    p_obs = p_obs + v_obs*(t_CAP+12);
    %else
    %    p_obs = p_obs - v_obs*(t_CAP+0.5)
    %end
    C = p_obs;
    CA = A-C;
    CW = W-C;
    CB = CW/norm(CW)*R_s;

    %B = C + CB;

    %theta = acos(dot(CA,CB)/(norm(CA)*norm(CB)));
    angle = atan2(CB(2),CB(1))-atan2(CA(2),CA(1));
    if (angle < 0) 
        angle = angle + 2*pi;
    end

    side = 1; % pass on right side of ostacle
    num_wp_oa = 1; % use one extra wp to pass obstacle 

    % 'HEAD_ON' = 1 'CROSSING_RIGHT' = 2 CROSSING_LEFT' = 3 'OVERTAKING' = 4
    % right = 1, left = 2

    if colregs_situation == 1 ||  colregs_situation == 2 
        %HEAD ON or CROSSING RIGHT
        side = 1;
    elseif colregs_situation == 3 % CROSSING LEFT
        num_wp_oa = 0;
    else % OVERTAKING
        if angle == pi
            side = 1;
        elseif angle > pi
            side = 2; %left
        end
    end

    d2 = dot(CW,CW);
    Q0 = C+R_ss^2/d2*CW;
    T = (R_ss/d2*sqrt(d2-R_ss^2)*CW'*[0 1;-1 0])';
    Q1 = Q0+T;
    Q2 = Q0-T;

    CQ1 = Q1-C;
    CQ2 = Q2-C;

    theta1 = atan2(CQ1(2),CQ1(1))-atan2(CB(2),CB(1));
    theta2 = atan2(CQ2(2),CQ2(1))-atan2(CB(2),CB(1));

    if theta1 < 0
        theta1 = theta1 + 2*pi;
    end
    if theta2 < 0
        theta2 = theta2 + 2*pi;
    end

    d2_a = dot(CA,CA);
    Q0_a = C+R_ss^2/d2_a*CA;
    T_a = (R_ss/d2_a*sqrt(d2_a-R_ss^2)*CA'*[0 1;-1 0])';
    Q1_a = Q0_a+T_a;
    Q2_a = Q0_a-T_a;

    CQ1_a = Q1_a-C;
    CQ2_a = Q2_a-C;

    theta1_a = atan2(CQ1_a(2),CQ1_a(1))-atan2(CA(2),CA(1));
    theta2_a = atan2(CQ2_a(2),CQ2_a(1))-atan2(CA(2),CA(1));

    if theta1_a < 0
        theta1_a = theta1_a + 2*pi;
    end
    if theta2_a < 0
        theta2_a = theta2_a + 2*pi;
    end

    if side == 1
        if theta1_a <= pi
            Q_a = Q1_a;
            CQ_a = CQ1_a;
        else
            Q_a = Q2_a;
            CQ_a = CQ2_a;
        end
        if theta1 >= pi
            Q = Q1;
            CQ = CQ1;
        else
            Q = Q2;
            CQ = CQ2;
        end
    elseif side == 2
        if theta1_a > pi
            Q_a = Q1_a;
            CQ_a = CQ1_a;
        else
            Q_a = Q2_a;
            CQ_a = CQ2_a;
        end
        if theta1 < pi
            Q = Q1;
            CQ = CQ1;
        else
            Q = Q2;
            CQ = CQ2;
        end
    end



    if side == 1
        alpha = atan2(CQ(2),CQ(1))-atan2(CQ_a(2),CQ_a(1));
    elseif side == 2
        alpha = atan2(CQ_a(2),CQ_a(1))-atan2(CQ(2),CQ(1));
    end
    if (alpha < 0) 
        alpha = alpha + 2*pi;
    end
    if alpha >= pi
        num_wp_oa = 2;
    end
    if side == 1    
        if num_wp_oa == 1
            intersection_point = find_intersection( Q_a,Q,CQ_a,CQ );
            wp_oa = [wp_oa; intersection_point'];

        elseif num_wp_oa == 2
            CD = RotMat(alpha/2)*CQ1_a;
            D = C + CD;

            intersection_point1 = find_intersection(Q_a,D,CQ_a,CD);
            intersection_point2 = find_intersection(D,Q,CD,CQ);

            wp_oa = [wp_oa; intersection_point1'; intersection_point2'];

        end
    elseif side == 2
        intersection_point = find_intersection( Q_a,Q,CQ_a,CQ );
        wp_oa = [wp_oa; intersection_point'];
    end
end
%}

%wp = [wp(1:k,:); G'; wp(k+1:length(wp),:)];

end

