% Parameters for Viknes 830 based on Loe, 2008.

global L W m I_z X_udot Y_vdot Y_rdot N_vdot N_rdot X_u Y_v Y_r N_v N_r;
global X_uu Y_vv N_rr X_uuu Y_vvv N_rrr
global Kp_u Kp_psi Td_psi l_r

%r = 10.0; % m (In reality 4.15 m)


L = 8.5;    % length [m]
W = 3;      % width [m]
m = 3980.0; % mass [kg]
I_z = 19703.0; % intertia [kg/m^2}
l_r = 4.0; % rudder_length

% Added mass terms
X_udot = 0.0;
Y_vdot = 0.0;
Y_rdot = 0.0;
N_vdot = 0.0;
N_rdot = 0.0;

% Linear damping terms [X_u, Y_v, Y_r, N_v, N_r]
X_u = -50.0;
Y_v = -200.0;
Y_r = 0.0;
N_v = 0.0;
N_r = -3224.0;

% Nonlinear damping terms [X_|u|u, Y_|v|v, N_|r|r, X_uuu, Y_vvv, N_rrr]
X_uu =   -135.0;
Y_vv =  -2000.0;
N_rr =      0.0;
X_uuu =     0.0;
Y_vvv =     0.0;
N_rrr = -3224.0;

% Force limits
Fx_min = -6550.0;
Fx_max = 13100.0;
Fy_min =  -645.0;
Fy_max =   645.0;


% Control parameters
Kp_u = 0.1;     %Proportional gain for speed controller
Kp_psi = 5.0;   %Proportional gain for heading controller
Td_psi = 1.0;   %Derivative time for heading controller

% Initial conditions
x0 = 0;
y0 = 0;
psi0 = 0;
u0 = 5;
v0 = 5;
r0 = 0;


