function [] = plot_sbg(x, y, psi, color, varargin)

global L W

drawArrow = @(x,y,color) quiver( x(1),y(1),x(2)-x(1),y(2)-y(1),0,'MaxHeadSize',5,'Color',color,'LineWidth',0.5); 

figure(1)
axis([-50  200 -50 200])
hold on

boat_shape = [L/2 0.5*L/2 -L/2 -L/2 0.5*L/2 L/2; 
        0 W/2 W/2 -W/2 -W/2 0];

plot_wp('b')
R_s = 70;
R_ss = 20;

for i=1:length(x)
    tmpR=[cos(psi(i)) -sin(psi(i)); sin(psi(i)) cos(psi(i))];
    boat = tmpR*boat_shape;
    h = patch(x(i)+boat(1,:),y(i)+boat(2,:),color);
    if nargin > 4
        x_b = varargin{1}; y_b = varargin{2}; psi_b = varargin{3}; color_b = varargin{4};
        tmpR_b=[cos(psi_b) -sin(psi_b); sin(psi_b) cos(psi_b)];
        boat_b = tmpR_b*boat_shape;
        h_b = patch(x_b(i)+boat_b(1,:),y_b(i)+boat_b(2,:),color_b);
        r_b_s = plot_radius(x_b(i),y_b(i),R_s,['--' color_b]);
        r_b_ss = plot_radius(x_b(i),y_b(i),R_ss,color_b);
        
    end
    F(i)=getframe(gcf);
    pause(0.1);
    delete(h);
    if i<length(x) && mod(i,2) == 0;
        drawArrow([x(i) x(i+1)],[y(i) y(i+1)],'b');
    end
    if nargin > 4
        delete(h_b);
        delete(r_b_s);
        delete(r_b_ss);
        if i<length(x_b) && mod(i,2) == 0;
            drawArrow([x_b(i) x_b(i+1)],[y_b(i) y_b(i+1)],color_b);
        end
    end
    
end

hold off
xlabel('East [m]')
ylabel('North [m]')

video = VideoWriter('TestMovie_sbg.avi','Uncompressed AVI');
video.FrameRate = 8;
open(video)
writeVideo(video,F);
close(video)
end

