function [ out ] = vesselmodel( eta, nu, tau )

global X_u Y_v Y_r N_v N_r X_udot Y_vdot Y_rdot N_vdot N_rdot
global X_uu Y_vv N_rr X_uuu Y_vvv N_rrr m I_z 

psi = eta(3); 
u = nu(1); v = nu(2); r = nu(3); 

w = [0 0 0]';

J = [cos(psi) -sin(psi) 0; sin(psi) cos(psi) 0; 0 0 1];

M_RB = [m 0 0; 0 m 0; 0 0 I_z];
M_A = -[X_udot 0 0; 0 Y_vdot Y_rdot; 0 N_vdot N_rdot];
M = M_RB + M_A;

C_RB = [0 0 -m*v; 0 0 m*u; m*v -m*u 0];
C_A = [0 0 -Y_vdot*v+((Y_rdot+N_vdot)/2)*r;
    0 0 X_udot*u; 
    Y_vdot*v+((Y_rdot+N_vdot)/2)*r -X_udot*u 0];
C = C_RB + C_A;

D_L = -[X_u 0 0; 0 Y_v Y_r; 0 N_v N_r];
D_NL = -[X_uu*abs(u) + X_uuu*u^2 0 0;
    0 Y_vv*abs(v) + Y_vvv*v^2 0;
    0 0 N_rr*abs(r) + N_rrr*r^2];
D = D_L + D_NL;

eta_dot = J*nu;
nu_dot = inv(M)*(w + tau - C*nu - D*nu);

out = [eta_dot; nu_dot];

end







